/*
 DRPC-1 fm data recive progam.
 programing on Libretto 20 - FreeBSD 2.2.5
 1999-07-07 Hiroki Mori
 This code based on Tsuyoshi Hatakenaka's DRPC-1 controle perl code.
 */

#include <stdio.h>
#include <fcntl.h>
#include <signal.h>
#include <setjmp.h>

#define PACKETSIZE	24
#define FREQ		800

char *spooldir = "spool/";

void sioinit(int);

int sio_port;

sig_t done() {
unsigned char cmd[4];

	cmd[0] = 0xb0;
	write(sio_port, cmd, 1);

	close(sio_port);
        exit(0);
}

main(argc, argv)
int argc;
char *argv[];
{
unsigned char data[PACKETSIZE], *buffer;
int i, j, size, indg, dgno, datasize, packetno, base;
char filename[32];
unsigned char cmd[4];
FILE *fp;

	sio_port = open(SIOPORT, O_RDWR);
	if(sio_port == -1) {
		printf("can not open port\n");
		exit(-1);
	}

	sioinit(sio_port);

	/* Power on */
	cmd[0] = 0x90;
	cmd[1] = 0xe0;
	write(sio_port, cmd, 2);
	usleep(10000);

	/* ??? */
	cmd[0] = 0x90;
	cmd[1] = 0xa0;
	write(sio_port, cmd, 2);
	usleep(10000);

	base = 0x051A + (FREQ - 760) * 2;
	cmd[0] = 0x80;
	cmd[1] = (base >> 8) & 0xff;
	cmd[2] = base & 0xff;
	cmd[3] = 0x10;
	write(sio_port, cmd, 4);
	usleep(10000);

	cmd[0] = 0xa0;
	write(sio_port, cmd, 1);

	signal(SIGINT,  (sig_t) done);

	buffer = (unsigned char *)malloc(1024);
	datasize = 0;
	indg = 0;
	while(1) {
		size = 0;
		while(size < PACKETSIZE)
			size += read(sio_port, data + size, PACKETSIZE - size);
#ifdef DEBUG
		for(i = 0; i < PACKETSIZE; ++i)
			printf("%02x ", data[i]);
		printf("\n");
#else
		
		if((data[2] & 0x0f) == 0x02 && !indg && data[5] == 0) {
			dgno = data[4];
			packetno = 0;
			indg = 1;
		}
		if((data[2] & 0x0f) == 0x02 && indg) {
			if(packetno != data[5] || data[4] != dgno) {
				datasize = 0;
				indg = 0;
			} else {
				++packetno;
				memcpy(buffer + datasize, &data[6], 18);
				datasize += 18;
				if(data[2] & 0x20 && 
					((buffer[1] & 0x7f) * 256 + buffer[2] 
					+ 3 + 18-1) / 18 * 18 == datasize) {
					sprintf(filename, "%s%02x%02x",
						spooldir, buffer[5], buffer[6]);
					printf("get file = %s, size = %d\n",
						filename, datasize);
					fp = fopen(filename, "wb");
					fwrite(buffer, datasize, 1, fp);
					fclose(fp);
					datasize = 0;
					indg = 0;
				}
			}
		}
#endif
	}

}
